//+------------------------------------------------------------------+
//|                         Ilan1.6_PipStep_Exponential_MFI_Lock.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

extern string     EAName               ="Ilan1.6_PipStep_Exponential_MFI_Lock";
extern bool       NewBarOpen           = TRUE;
extern bool       Buy                  = TRUE;    
extern bool       Sell                 = TRUE;    
extern double     LotExponent          = 1.5;     
extern double     LockExp              = 1.5;     
extern double     slip                 = 10.0;     
extern double     Lots                 = 0.01;     
extern int        lotdecimal           = 2;       
extern double     TakeProfit1          = 10.0;
extern double     TakeProfit2          = 4;       
extern double     Pipstep              = 30.0;    
extern double     PipStepExponent      = 1.5;     
extern int        MaxTrades            = 10;       
extern int        MagicNumber          = 12345;
extern int        PerMFI               = 4; 
extern int        RSI_Per              = 16;
extern double     RsiMinimum           = 50.0;    
extern double     RsiMaximum           = 50.0;
extern bool       UseEquityStop        = FALSE;
extern double     TotalEquityRisk      = 20.0;
extern bool       UseTrailingStop      = FALSE;
extern double     TrailStart           = 30.0;
extern double     TrailStop            = 20.0;
extern bool       UseTimeOut           = FALSE;  
extern double     MaxTradeOpenHours    = 48.0;    
extern double     Reinvest             = 0;       

//***********************************************************************************************************************************
//***********************************************************************************************************************************

int      Nbar              = 2;
double   Stoploss          = 2000.0;
int      timeprev          = 0, expiration;
int      NumOfTrades       = 0;
int      cnt               = 0, total;
double   Stopper           = 0.0;
bool     TradeNow          = FALSE; 
bool     LongTrade         = FALSE; 
bool     ShortTrade        = FALSE;
bool     NewOrdersPlaced   = FALSE;


double   KolLock; 
double   TakeProfit;                  
double   PriceTarget; 
double   StartEquity; 
double   BuyTarget; 
double   SellTarget;
double   AveragePrice; 
double   SellLimit; 
double   BuyLimit;
double   LastBuyPrice; 
double   LastSellPrice; 
double   Spread;
bool     flag;
double   iLots;
double   PipStep;
int      ticket;
double   AccountEquityHighAmt; 
double   PrevEquity;

//***********************************************************************************************************************************
//***********************************************************************************************************************************

int init()
{
    init1(); init2();
    return(0);
}
int deinit()
{ 
    deinit1(); deinit2();
    return(0);
}
int start()
{
    start1(); 
    start2();
    return(0);
}

int init1() 
{
   Spread = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   return (0);
}

int deinit1() 
{
   return (0);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

int start1() 
{

   total = CountTrades();
   KolLock = MaxTrades;
   
   if (total >= MaxTrades - 1 && total >= 1) 
   {
      TakeProfit = TakeProfit2;
   }
   else TakeProfit = TakeProfit1;
      
   double MFI     = iMFI(NULL,0,PerMFI,1);
   double MFI0    = iMFI(NULL,0,PerMFI,0);
   double RSI     = iRSI(NULL,0,RSI_Per,0,0);
   double SignCCI = iCCI(NULL,0,55,0,0);
   
   PipStep = NormalizeDouble(Pipstep * MathPow(PipStepExponent, NumOfTrades), 0);
   
   if (UseTrailingStop && total < MaxTrades) TrailingAlls(TrailStart, TrailStop, AveragePrice);
   if (UseTimeOut) 
   {
      if (TimeCurrent() >= expiration) 
      {
         CloseThisSymbolAll();
         Print("Closed All due to TimeOut");
      }
   }

   double CurrentPairProfit = CalculateProfit();
   if (UseEquityStop) 
   {
      if (CurrentPairProfit < 0.0 && MathAbs(CurrentPairProfit) > TotalEquityRisk / 100.0 * AccountEquityHigh()) 
      {
         CloseThisSymbolAll();
         Print("Closed All due to Stop Out");
         NewOrdersPlaced = FALSE;
      }
   }
   if (total > MaxTrades) {
      if (CurrentPairProfit > 100.0 * GetLots()) 
      {
         CloseThisSymbolAll();
         Print("Closed All due to Lock Profit");
         NewOrdersPlaced = FALSE;
      }
   }
   if (total > KolLock && LockExp == 1) 
   {
      PriceTarget = 0;
      for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderTakeProfit() > 0) OrderModify(OrderTicket(), NormalizeDouble(OrderOpenPrice(),Digits), NormalizeDouble(OrderStopLoss(),Digits), NormalizeDouble(PriceTarget,Digits), 0, Yellow);
      }
   }
   if (NewBarOpen) 
   {
      if (timeprev == Time[0]) return (0);
      timeprev = Time[0];
   }
   if (total == 0) flag = FALSE;
   for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
      {
         if (OrderType() == OP_BUY) 
         {
            LongTrade = TRUE;
            ShortTrade = FALSE;
            break;
         }
      }
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
      {
         if (OrderType() == OP_SELL) 
         {
            LongTrade = FALSE;
            ShortTrade = TRUE;
            break;
         }
      }
   }
   if (total > 0 && total <= MaxTrades) 
   {
      RefreshRates();
      LastBuyPrice = FindLastBuyPrice();
      LastSellPrice = FindLastSellPrice();
      if (total >= KolLock) MFI = 10;
      if (NewBarOpen) 
      {       
      if (LongTrade && LastBuyPrice - Ask >= PipStep * Point && MFI<20) TradeNow = TRUE;
      } 
      else if (LongTrade && LastBuyPrice - Ask >= PipStep * Point) TradeNow = TRUE;
      if (total >= KolLock) MFI = 90;
      if (NewBarOpen) 
      {       
         if (ShortTrade && Bid - LastSellPrice >= PipStep * Point && MFI>80) TradeNow = TRUE;
      } 
      else if (ShortTrade && Bid - LastSellPrice >= PipStep * Point) TradeNow = TRUE; 
   }
   if (total < 1) 
   {
      ShortTrade = FALSE;
      LongTrade = FALSE;
      TradeNow = TRUE;
      StartEquity = AccountEquity();
   }
   if (TradeNow) 
   {
      LastBuyPrice = FindLastBuyPrice();
      LastSellPrice = FindLastSellPrice();
      if (ShortTrade) 
      {
         NumOfTrades = total;
         iLots = NormalizeDouble(GetLots() * MathPow(LotExponent, NumOfTrades), lotdecimal);
         RefreshRates();
         if (KolLock == total)
         {
            ticket = OpenPendingOrder(0, NormalizeDouble(SumLots()*LockExp, lotdecimal), NormalizeDouble(Ask,Digits), slip, NormalizeDouble(Bid,Digits), 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, Blue);
         }
         else
         {
            ticket = OpenPendingOrder(1, iLots, NormalizeDouble(Bid,Digits), slip, NormalizeDouble(Ask,Digits), 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, HotPink);
         }
         if (ticket < 0) 
         {
            Print("Error: ", GetLastError());
            return (0);
         }
         LastSellPrice = FindLastSellPrice();
         TradeNow = FALSE;
         NewOrdersPlaced = TRUE;
      } 
      else 
      {
         if (LongTrade) 
         {
            NumOfTrades = total;
            iLots = NormalizeDouble(GetLots() * MathPow(LotExponent, NumOfTrades), lotdecimal);
         if (KolLock == total)
            {
             ticket = OpenPendingOrder(1, NormalizeDouble(SumLots()*LockExp, lotdecimal), NormalizeDouble(Bid,Digits), slip, NormalizeDouble(Ask,Digits), 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, HotPink);
             }
         else
            {        
            ticket = OpenPendingOrder(0, iLots, NormalizeDouble(Ask,Digits), slip, NormalizeDouble(Bid,Digits), 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, Blue);
            }
            if (ticket < 0) 
            {
               Print("Error: ", GetLastError());
               return (0);
            }
            LastBuyPrice = FindLastBuyPrice();
            TradeNow = FALSE;
            NewOrdersPlaced = TRUE;
         }
      }
   }
   if (TradeNow && total < 1) 
   {
      double PrevCl = iClose(Symbol(), 0, Nbar);
      double CurrCl = iClose(Symbol(), 0, 0);
      SellLimit = NormalizeDouble(Bid, Digits);
      BuyLimit = NormalizeDouble(Ask, Digits);
      if (!ShortTrade && !LongTrade) 
      {
         NumOfTrades = total;
         iLots = NormalizeDouble(GetLots() * MathPow(LotExponent, NumOfTrades), lotdecimal);
         if (Sell) {
            if (PrevCl > CurrCl && MFI0 > 20 && RSI < RsiMinimum && SignCCI > (-100)) 
            {
               ticket = OpenPendingOrder(1, iLots, SellLimit, slip, SellLimit, 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, HotPink);
               if (ticket < 0) 
               {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               LastSellPrice = FindLastSellPrice();
               NewOrdersPlaced = TRUE;
            }
         }
         if (Buy) 
         {
            if (PrevCl < CurrCl && MFI0 < 80 && RSI > RsiMaximum && SignCCI < 100) 
            {
               ticket = OpenPendingOrder(0, iLots, BuyLimit, slip, BuyLimit, 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, Blue);
               if (ticket < 0) 
               {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               LastBuyPrice = FindLastBuyPrice();
               NewOrdersPlaced = TRUE;
            }
         }
         if (ticket > 0) expiration = TimeCurrent() + 60.0 * (60.0 * MaxTradeOpenHours);
         TradeNow = FALSE;
      }
   }
   total = CountTrades();
   AveragePrice = 0;
   double Count = 0;
   for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
      {
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) 
         {
            AveragePrice += OrderOpenPrice() * OrderLots();
            Count += OrderLots();
            if (total <= MaxTrades && OrderTakeProfit() == 0) NewOrdersPlaced = TRUE;            
         }
      }
   }
   if (total > 0) AveragePrice = NormalizeDouble(AveragePrice / Count, Digits);
   if (NewOrdersPlaced) 
   {
      for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
            if (OrderType() == OP_BUY) 
            {
               PriceTarget = AveragePrice + TakeProfit * Point;
               BuyTarget = PriceTarget;
               Stopper = AveragePrice - Stoploss * Point;
               flag = TRUE;
            }
         }
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
            if (OrderType() == OP_SELL) 
            {
               PriceTarget = AveragePrice - TakeProfit * Point;
               SellTarget = PriceTarget;
               Stopper = AveragePrice + Stoploss * Point;
               flag = TRUE;
            }
         }
      }
   }
   if (NewOrdersPlaced&&CountTrades()<=MaxTrades) 
   {
      if (flag == TRUE) 
      {
         for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) OrderModify(OrderTicket(), NormalizeDouble(AveragePrice,Digits), NormalizeDouble(OrderStopLoss(),Digits), NormalizeDouble(PriceTarget,Digits), 0, Yellow);
            NewOrdersPlaced = FALSE;
         }
      }
   }
   return (0);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double SumLots() 
{
    double sumLot = 0;
    for (int trade = OrdersTotal() - 1; trade >= 0; trade--) 
    {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      if (OrderType() == OP_SELL || OrderType() == OP_BUY)sumLot = sumLot+OrderLots();
    }
   return (sumLot);
}  

//***********************************************************************************************************************************
//***********************************************************************************************************************************

int CountTrades() 
{
   int count = 0;
   for (int trade = OrdersTotal() - 1; trade >= 0; trade--) 
   {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      if (OrderType() == OP_SELL || OrderType() == OP_BUY) count++;
   }
   return (count);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

void CloseThisSymbolAll() 
{
   for (int trade = OrdersTotal() - 1; trade >= 0; trade--) 
   {
     OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol() == Symbol()) 
     {
       if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
       if (OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), slip, Blue);
       if (OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), slip, Red);
     }
     Sleep(1000);
      }
   }
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

int OpenPendingOrder(int pType, double pLots, double pLevel, int sp, double pr, int sl, int tp, string pComment, int pMagic, int pDatetime, color pColor) 
{
   int ticket = 0;
   int err = 0;
   int c = 0;
   int NumberOfTries = 100;
   switch (pType) 
   {
   case 2:
      for (c = 0; c < NumberOfTries; c++) 
      {
         ticket = OrderSend(Symbol(), OP_BUYLIMIT, pLots, pLevel, sp, StopLong(pr, sl), TakeLong(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0) break;
         if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
         Sleep(1000);
      }
   break;
   
   case 4:
      for (c = 0; c < NumberOfTries; c++) 
      {
         ticket = OrderSend(Symbol(), OP_BUYSTOP, pLots, pLevel, sp, StopLong(pr, sl), TakeLong(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0) break;
         if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
         Sleep(5000);
      }
   break;
   
   case 0:
      for (c = 0; c < NumberOfTries; c++) 
      {
         RefreshRates();
         ticket = OrderSend(Symbol(), OP_BUY, pLots, NormalizeDouble(Ask,Digits), sp, StopLong(NormalizeDouble(Bid,Digits), sl), TakeLong(NormalizeDouble(Ask,Digits), tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0) break;
         if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
         Sleep(5000);
      }
   break;
   
   case 3:
      for (c = 0; c < NumberOfTries; c++) 
      {
         ticket = OrderSend(Symbol(), OP_SELLLIMIT, pLots, pLevel, sp, StopShort(pr, sl), TakeShort(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0) break;
         if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
         Sleep(5000);
      }
   break;
   
   case 5:
      for (c = 0; c < NumberOfTries; c++) 
      {
         ticket = OrderSend(Symbol(), OP_SELLSTOP, pLots, pLevel, sp, StopShort(pr, sl), TakeShort(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0) break;
         if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
         Sleep(5000);
      }
   break;
   
   case 1:
      for (c = 0; c < NumberOfTries; c++) 
      {
         ticket = OrderSend(Symbol(), OP_SELL, pLots, NormalizeDouble(Bid,Digits), sp, StopShort(NormalizeDouble(Ask,Digits), sl), TakeShort(NormalizeDouble(Bid,Digits), tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0) break;
         if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
         Sleep(5000);
      }
   }
   return (ticket);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double StopLong(double price, int stop) 
{
   if (stop == 0) return (0);
   else return (price - stop * Point);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double StopShort(double price, int stop) 
{
   if (stop == 0) return (0);
   else return (price + stop * Point);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double TakeLong(double price, int stop) 
{
   if (stop == 0) return (0);
   else return (price + stop * Point);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double TakeShort(double price, int stop) 
{
   if (stop == 0) return (0);
   else return (price - stop * Point);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double CalculateProfit() 
{
   double Profit = 0;
   for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) Profit += OrderProfit();
   }
   return (Profit);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

void TrailingAlls(int pType, int stop, double AvgPrice) 
{
   int profit;
   double stoptrade;
   double stopcal;
   if (stop != 0) 
   {
      for (int trade = OrdersTotal() - 1; trade >= 0; trade--) 
      {
         if (OrderSelect(trade, SELECT_BY_POS, MODE_TRADES)) 
         {
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
            if (OrderSymbol() == Symbol() || OrderMagicNumber() == MagicNumber) 
            {
               if (OrderType() == OP_BUY) 
               {
                  profit = NormalizeDouble((Bid - AvgPrice) / Point, 0);
                  if (profit < pType) continue;
                  stoptrade = OrderStopLoss();
                  stopcal = Bid - stop * Point;
                  if (stoptrade == 0.0 || (stoptrade != 0.0 && stopcal > stoptrade)) OrderModify(OrderTicket(), AvgPrice, stopcal, OrderTakeProfit(), 0, Aqua);
               }
               if (OrderType() == OP_SELL) 
               {
                  profit = NormalizeDouble((AvgPrice - Ask) / Point, 0);
                  if (profit < pType) continue;
                  stoptrade = OrderStopLoss();
                  stopcal = Ask + stop * Point;
                  if (stoptrade == 0.0 || (stoptrade != 0.0 && stopcal < stoptrade)) OrderModify(OrderTicket(), AvgPrice, stopcal, OrderTakeProfit(), 0, Red);
               }
            }
            Sleep(1000);
         }
      }
   }
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double AccountEquityHigh() 
{
   if (CountTrades() == 0) AccountEquityHighAmt = AccountEquity();
   if (AccountEquityHighAmt < PrevEquity) AccountEquityHighAmt = PrevEquity;
   else AccountEquityHighAmt = AccountEquity();
   PrevEquity = AccountEquity();
   return (AccountEquityHighAmt);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double FindLastBuyPrice() 
{
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY) 
      {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) 
         {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}

double FindLastSellPrice() 
{
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) 
      {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) 
         {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************

double GetLots() 
{
	double minLot	 = MarketInfo(Symbol(), MODE_MINLOT);
	double maxLot	 = MarketInfo(Symbol(), MODE_MAXLOT);
	double balance	 = AccountBalance();

   if(Reinvest!=0)
   {
      double lot = NormalizeDouble(balance * Reinvest / 1000 / 100, 2);
      if(lot < minLot) lot = minLot;
      if(lot > maxLot) lot = maxLot;
   } 
   else lot = Lots; 
   return(lot);
} 

//***********************************************************************************************************************************
//***********************************************************************************************************************************

//                         ** CLOSE PROFIT **

//***********************************************************************************************************************************
//***********************************************************************************************************************************
extern string CloseProfit     = "CLOSE PROFIT";
extern double ProfitClose     = 1;  
extern double LossClose       = 1000; 
extern bool   AllSymbol       = false;

string txt;
int init2()
{
   ObjectCreate("Balance", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Balance", OBJPROP_CORNER, 1);
   ObjectSet("Balance", OBJPROP_XDISTANCE,70);
   ObjectSet("Balance", OBJPROP_YDISTANCE, 15);
   ObjectCreate("Equity", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Equity", OBJPROP_CORNER, 1);
   ObjectSet("Equity", OBJPROP_XDISTANCE, 70);
   ObjectSet("Equity", OBJPROP_YDISTANCE, 25);
   ObjectCreate("Profit", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Profit", OBJPROP_CORNER, 1);
   ObjectSet("Profit", OBJPROP_XDISTANCE,70);
   ObjectSet("Profit", OBJPROP_YDISTANCE, 35);
   ObjectCreate("Copyright", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Copyright", OBJPROP_CORNER, 3);
   ObjectSet("Copyright", OBJPROP_XDISTANCE, 5);
   ObjectSet("Copyright", OBJPROP_YDISTANCE, 5);
   ObjectSetText("Copyright","CloseProfit",8,"Arial",Gold);
   if (AllSymbol) txt = "FULL";
   return(0);
}

//***********************************************************************************************************************************

int deinit2()
{
   ObjectDelete("Balance");
   ObjectDelete("Equity");
   ObjectDelete("Profit");
   ObjectDelete("Copyright");
   return(0);
}

//***********************************************************************************************************************************

int start2()
{
   double Profit;
   int b,s,OT;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() || AllSymbol)
         {
            OT = OrderType();
            if (OT==OP_BUY)
            {
               b++;
               Profit+=OrderProfit();
            }
            if (OT==OP_SELL)
            {
               s++;
               Profit+=OrderProfit();
            }
         }
      }
   }
   Comment(txt,"\nBuy ",b,"\nSell ",s);
   
   if (Profit>=ProfitClose) 
   {
      Alert("PC = "+DoubleToStr(Profit,2));
      CloseAll();
   }
   if (Profit<=-LossClose)
   {
      Alert("LC "+DoubleToStr(Profit,2));
      CloseAll();
   }
   ObjectSetText("Balance",StringConcatenate("Balance ",DoubleToStr(AccountBalance(),2)),8,"Arial",Gold);
   ObjectSetText("Equity",StringConcatenate("Equity ",DoubleToStr(AccountEquity(),2)),8,"Arial",Gold);
   if (AllSymbol) ObjectSetText("Profit",StringConcatenate("Profit All Symbol ",DoubleToStr(Profit,2)),8,"Arial",Color(Profit));
   else ObjectSetText("Profit",StringConcatenate("Profit ",DoubleToStr(Profit,2)),8,"Arial",Color(Profit));
return;
}

//***********************************************************************************************************************************

color Color(double P)
{
   if (P>0) return(Green);
   if (P<0) return(Red);
   if (P==0) return(Green);
}

//***********************************************************************************************************************************

bool CloseAll()
{
   bool error=true;
   int err,nn,OT;
   string Symb;
   while(true)
   {
      for (int j = OrdersTotal()-1; j >= 0; j--)
      {
         if (OrderSelect(j, SELECT_BY_POS))
         {
            Symb = OrderSymbol();
            if (Symb == Symbol() || AllSymbol)
            {
               OT = OrderType();
               if (OT>1) 
               {
                  OrderDelete(OrderTicket());
               }
               if (OT==OP_BUY) 
               {
                  error=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symb,MODE_BID),MarketInfo(Symb,MODE_DIGITS)),3,Blue);
                  if (error) Alert(Symb,"   N ",OrderTicket(),"  N ",OrderProfit(),
                                     "     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
               if (OT==OP_SELL) 
               {
                  error=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symb,MODE_ASK),MarketInfo(Symb,MODE_DIGITS)),3,Red);
                  if (error) Alert(Symb,"   N ",OrderTicket(),"  N ",OrderProfit(),
                                     "     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
               if (!error) 
               {
                  err = GetLastError();
                  if (err<2) continue;
                  if (err==129) 
                  {  Comment("T ",TimeToStr(TimeCurrent(),TIME_MINUTES));
                     Sleep(5000);
                     RefreshRates();
                     continue;
                  }
                  if (err==146) 
                  {
                     if (IsTradeContextBusy()) Sleep(2000);
                     continue;
                  }
                  Comment("T ",err," N ",OrderTicket(),
                          "     ",TimeToStr(TimeCurrent(),TIME_MINUTES));
               }
            }
         }
      }
      int n=0;
      for (j = 0; j < OrdersTotal(); j++)
      {
         if (OrderSelect(j, SELECT_BY_POS))
         {
            if (OrderSymbol() == Symbol() || AllSymbol)
            {
               OT = OrderType();
               if (OT==OP_BUY || OT==OP_SELL) n++;
            }
         }  
      }
      if (n==0) break;
      nn++;
      if (nn>10) {Alert(Symb,"  N ",n);return(0);}
      Sleep(1000);
      RefreshRates();
   }
   return(1);
}

//***********************************************************************************************************************************
//***********************************************************************************************************************************